Drop sarge from interface, docs and script
[grml-debootstrap.git] / grml-debootstrap
index 0182ee9..233e53a 100755 (executable)
@@ -11,7 +11,7 @@ set -e # exit on any error
 
 # variables {{{
 PN="$(basename $0)"
-VERSION='0.18'
+VERSION='0.24'
 MNTPOINT="/mnt/debootstrap.$$"
 
 # inside the chroot system locales might not be available, so use minimum:
@@ -34,27 +34,45 @@ usage() {
 
 Usage: $PN [options]
 
-  -h|--help                   Print this usage information and exit.
-  -v|--version                Show summary of options and exit.
-
-  -c|--config <configfile>    Use specified configuration file,
-                              defaults to /etc/debootstrap/config
-  -i|--iso <mnt>              Mountpoint where a Debian ISO is mounted to,
-                              for use instead of fetching packages from a mirror
-  -m|--mirror <URL>           Mirror which should be used for apt-get/aptitude.
-  -p|--mntpoint <mnt>         Mountpoint used for mounting the target system.
-  -r|--release <release>      Release of new Debian system (default: stable)
-  -t|--target <target>        Target partition (/dev/...) or directory.
-
-  --boot_append <appendline>  Add specified appendline to kernel whilst booting
-  --groot <device>            Root device for usage in grub, corresponds with
-                              \$TARGET in grub syntax, like hd0,0 for /dev/sda1
-  --grub <device>             Target for grub installation. Use grub syntax
-                              for specifying, like hd0 for /dev/sda
-  --interactive               Use interactive mode (frontend)
-  --password <pwd>            Use specified password as password for user root.
-
-Send bugreports to the grml-team: bugs@grml.org || http://grml.org/bugs/
+Bootstrap options:
+
+  -m, --mirror <URL>     Mirror which should be used for apt-get/aptitude.
+  -i, --iso <mnt>        Mountpoint where a Debian ISO is mounted to, for use
+                           instead of fetching packages from a mirror.
+  -r, --release <name>   Release of new Debian system (default: stable).
+  -t, --target <target>  Target partition (/dev/...) or directory.
+  -p, --mntpoint <mnt>   Mountpoint used for mounting the target system.
+      --debopt <params>  Extra parameters passed to the debootstrap.
+      --interactive      Use interactive mode (frontend).
+      --nodebootstrap    Skip debootstrap, only do configuration to the target.
+      --groot <device>   Root device for usage in grub, corresponds with
+                           \$TARGET in grub syntax, like hd0,0 for /dev/sda1.
+      --grub <device>    Target for grub installation. Use grub syntax for
+                           specifying, like hd0 for /dev/sda.
+
+Configuration options:
+
+  -c, --config <file>      Use specified configuration file, defaults to
+                             /etc/debootstrap/config
+  -d, --confdir <path>     Place of config files for debootstrap, defaults
+                             to /etc/debootstrap
+      --packages <file>    Install packages defined in specified list file.
+      --debconf <file>     Pre-seed packages using specified pre-seed db file.
+      --keep_src_list      Do not overwrite user provided apt sources.list.
+      --hostname <name>    Hostname of Debian system.
+      --password <pwd>     Use specified password as password for user root.
+      --bootappend <line>  Add specified appendline to kernel whilst booting.
+      --chroot-scripts <d> Execute chroot scripts from specified directory.
+      --scripts <dir>      Execute scripts from specified directory.
+
+Other options:
+
+  -v, --verbose            Increase verbosity.
+  -h, --help               Print this usage information and exit.
+  -V, --version            Show summary of options and exit.
+
+Usage examples can be found in the grml-debootstrap manpage.
+Send bugreports to the grml-team: bugs (at) grml.org || http://grml.org/bugs/
 "
 }
 
@@ -73,6 +91,7 @@ check4root || exit 1
 # source configuration file {{{
 if [ -r /etc/debootstrap/config ] ; then
    if [ -n "$CONFIGFILE" ] ; then
+      einfo "Using config file $CONFIGFILE."
       if ! . "$CONFIGFILE" ; then
          eerror "Error reading config file $CONFIGFILE" ; eend 1 ; exit 1
       fi
@@ -83,69 +102,65 @@ fi
 # }}}
 
 # cmdline handling {{{
+# source external command line parameter-processing script
+if [ -r /usr/share/grml-debootstrap/functions/cmdlineopts.clp ] ; then
+   . /usr/share/grml-debootstrap/functions/cmdlineopts.clp
+elif [ -r ./cmdlineopts.clp ] ; then
+   . ./cmdlineopts.clp
+else
+   echo "Error: cmdline function file not found, exiting.">&2
+   exit 1
+fi
 
-while [ "$#" -gt "0" ] ; do
-    case $1 in
-        -c|--config)
-            shift
-            CONFIGFILE=$1
-            ;;
-        --grub)
-            shift
-            GRUB=$1
-            ;;
-        --groot)
-            shift
-            GROOT=$1
-            ;;
-        -h|--help)
-            usage ; eend 0
-            eend 0
-            exit 0
-            ;;
-        --interactive)
-            INTERACTIVE=1
-            ;;
-        -i|--iso)
-            shift
-            [ -n "$MIRROR" ] && unset MIRROR
-            ISO=$1
-            ;;
-        -m|--mirror)
-            shift
-            MIRROR=$1
-            CHROOTMIRROR=$1
-            ;;
-        -p|--mntpoint)
-            shift
-            MNTPOINT=$1
-            ;;
-        --password)
-            shift
-            ROOTPASSWORD=$1
-            ;;
-        -r|--release)
-            shift
-            RELEASE=$1
-            ;;
-        -t|--target)
-            shift
-            TARGET=$1
-            ;;
-        -v|--version)
-            einfo "$PN - version $VERSION"
-            einfo "Send bug reports to bugs@grml.org or http://grml.org/bugs/"
-            eend 0
-            exit 0
-            ;;
-        *)
-            eerror "Syntax error."
-            usage ; eend 1
-            exit 1
-            ;;
-    esac
-    shift
-done
+# == business-logic of command line parameter-processing
+
+# source configuration file in <confdir> if supplied. {{{
+[ "$_opt_confdir" ] && {
+  CONFFILES=$_opt_confdir
+  einfo "Using config files under $CONFFILES/."
+  if ! [ -r "$CONFFILES/config" ] ; then
+    eerror "Error: config file $CONFFILES/config not found."; eend 1; exit 1
+  fi
+  if ! . "$CONFFILES/config" ; then
+    eerror "Error reading config file $CONFFILES/config" ; eend 1 ; exit 1
+  fi
+  # restore the command line parameter value
+  CONFFILES=$_opt_confdir
+}
+# }}}
+
+[ "$_opt_mirror" ]             && MIRROR=$_opt_mirror
+[ "$_opt_iso" ]                        && ISO=$_opt_iso
+[ "$_opt_release" ]            && RELEASE=$_opt_release
+[ "$_opt_target" ]             && TARGET=$_opt_target
+[ "$_opt_mntpoint" ]           && MNTPOINT=$_opt_mntpoint
+[ "$_opt_debopt" ]             && DEBOOTSTRAP_OPT=$_opt_debopt
+[ "$_opt_interactive" ]                && INTERACTIVE=1
+[ "$_opt_config" ]             && CONFIGFILE=$_opt_config
+[ "$_opt_packages_set" ]       && PACKAGES='yes'
+[ "$_opt_debconf_set" ]                && DEBCONF='yes'
+[ "$_opt_scripts_set" ]         && SCRIPTS='yes'
+[ "$_opt_chroot_scripts_set" ]  && CHROOT_SCRIPTS='yes'
+[ "$_opt_keep_src_list" ]      && KEEP_SRC_LIST='yes'
+[ "$_opt_hostname" ]           && HOSTNAME=$_opt_hostname
+[ "$_opt_password" ]           && ROOTPASSWORD=$_opt_password
+[ "$_opt_bootappend" ]         && BOOT_APPEND=$_opt_bootappend
+[ "$_opt_groot" ]              && GROOT=$_opt_groot
+[ "$_opt_grub" ]               && GRUB=$_opt_grub
+[ "$_opt_verbose" ]            && VERBOSE="-v"
+
+[ "$_opt_help" ] && {
+  usage ; eend 0
+  eend 0
+  exit 0
+}
+
+[ "$_opt_version" ] && {
+  einfo "$PN - version $VERSION"
+  einfo "Send bug reports to bugs@grml.org or http://grml.org/bugs/"
+  eend 0
+  exit 0
+}
 # }}}
 
 # welcome screen {{{
@@ -164,7 +179,14 @@ prompt_for_target()
                grep -v 'Extended$' | \
                gawk -v num=0 -v ORS=' ' '/^\/dev\// {print $1}')
 
-  [ -n "$AVAILABLE_PARTITIONS" ] || echo "FIXME: no partitions available?"
+  if [ -z "$AVAILABLE_PARTITIONS" ] ; then
+     dialog --title "$PN" --trim \
+     --msgbox "Sorry, no partitions found. Please configure your
+     harddisks (see /proc/partitions) using a tool like fdisk,
+     cfdisk, gpart, gparted,..." 0 0
+     exit 0
+  fi
+
   PARTITION_LIST=$(for i in $(echo $AVAILABLE_PARTITIONS) ; do
                        echo "$i $(vol_id --type $i 2>/dev/null || echo [no_filesystem_yet])"
                    done)
@@ -189,15 +211,15 @@ prompt_for_bootmanager()
 
   OIFS="$IFS"; IFS=:
 
-  if echo $TARGET | grep -q "*md*" ; then
-     MBRPART=$TARGET
+  if echo $TARGET | grep -q "/dev/md" ; then
+     MBRPART="all disks of Software RAID $TARGET"
   else
-     MBRPART="${TARGET%[0-9]}"
+     MBRPART="MBR of ${TARGET%[0-9]}"
   fi
 
   GETMBR=$(dialog --stdout --title "$PN" --default-item mbr \
           --menu "Where do you want to install the bootmanager grub?" 0 0 0 \
-            mbr       "install bootmanager into MBR of $MBRPART" \
+            mbr       "install bootmanager into $MBRPART" \
             partition "install bootmanager into partition $TARGET" \
             nowhere   "do not install bootmanager at all" \
           ${ADDITIONAL_PARAMS})
@@ -232,12 +254,43 @@ prompt_for_bootmanager()
 # ask for Debian release {{{
 prompt_for_release()
 {
-  RELEASE="$(dialog --stdout --title "${PN}" --default-item etch --menu \
+  RELEASE="$(dialog --stdout --title "${PN}" --default-item lenny --menu \
             "Please enter the Debian release you would like to use for installation:" \
             0 50 3 \
-            etch   Debian/stable \
-            lenny  Debian/testing \
-            sid    Debian/unstable)"
+            etch     Debian/old-stable \
+            lenny    Debian/stable \
+            squeeze  Debian/testing \
+            sid      Debian/unstable)"
+}
+# }}}
+
+# ask for hostname {{{
+prompt_for_hostname()
+{
+  HOSTNAME="$(dialog --stdout --title "${PN}" --inputbox \
+            "Please enter the hostname you would like to use for installation:" \
+            0 0 $HOSTNAME)"
+}
+# }}}
+
+# ask for password {{{
+prompt_for_password()
+{
+     ROOTPW1='PW1'
+     ROOTPW2='PW2'
+     while [ "$ROOTPW1" != "$ROOTPW2" ]; do
+       ROOTPW1=$(dialog --insecure --stdout --title "${PN}" --passwordbox \
+       "Please enter the password for the root account:" 10 60)
+       ROOTPW2=$(dialog --insecure --stdout --title "${PN}" --passwordbox \
+       "Please enter the password for the root account again for \
+       confirmation:" 10 60)
+
+       if [ "$ROOTPW1" != "$ROOTPW2" ]; then
+         $(dialog --stdout --title "${PN}" --ok-label \
+         "Retry" --msgbox "Passwords do not match!" 10 60)
+       fi
+     done
+     ROOTPASSWORD="$ROOTPW1"
 }
 # }}}
 
@@ -246,7 +299,7 @@ prompt_for_mirror()
 {
   MIRROR="$(dialog --stdout --title "${PN}" --inputbox \
             "Please enter Debian mirror you would like to use for installing packages." \
-            0 0 http://ftp.de.debian.org/debian)"
+            0 0 $MIRROR)"
 }
 # }}}
 
@@ -293,11 +346,15 @@ grubdevice() {
 config_swraid_setup()
 {
 TMPFILE=$(mktemp)
-RAIDLEVEL=$(dialog --stdout --title "$PN" --default-item raid1 \
-                   --menu "Which RAID level do you want to use?" 0 0 0 \
-                     raid1 "Software RAID level 1" \
-                     raid5 "Software RAID level 5")
-[ $? -eq 0 ] || bailout 20
+
+# Currently we support only raid1:
+RAIDLEVEL='raid1'
+
+#RAIDLEVEL=$(dialog --stdout --title "$PN" --default-item raid1 \
+#                   --menu "Which RAID level do you want to use?" 0 0 0 \
+#                     raid1 "Software RAID level 1" \
+#                     raid5 "Software RAID level 5")
+#[ $? -eq 0 ] || bailout 20
 
 MD_LIST=$(for i in $(seq 0 9) ; do
             awk '{print $4}' /proc/partitions | grep -q md$i || \
@@ -320,8 +377,7 @@ PARTITION_LIST=$(for i in $(echo $AVAILABLE_PARTITIONS) ; do
                      echo "$i $(vol_id --type $i 2>/dev/null || echo [no_filesystem_yet]) off"
                  done)
 
-dialog --title "$PN" \
-       --single-quoted \
+dialog --title "$PN" --separate-output \
        --checklist "Please select the partitions you would like to use for your $RAIDLEVEL on ${TARGET}:" 0 0 0 \
        $PARTITION_LIST 2>$TMPFILE
 RETVAL=$?
@@ -362,7 +418,7 @@ prompt_for_swraid()
 if dialog --stdout --title "$PN" \
           --defaultno --yesno "Do you want to configure Software RAID?
 
-Please notice that currently only RAID levels 1 and 5 are supported by ${PN}. Configuration will take place using mdadm." 0 0 ; then
+Please notice that only RAID level 1 is supported by ${PN} currently. Configuration will take place using mdadm." 0 0 ; then
   config_swraid_setup
 fi
 }
@@ -386,12 +442,14 @@ elif [ -n "$INTERACTIVE" ] ; then
    Install grub:    $GRUB"
    [ -n "$RELEASE" ] && INFOTEXT="$INFOTEXT
    Using release:   $RELEASE"
+   [ -n "$HOSTNAME" ] && INFOTEXT="$INFOTEXT
+   Using hostname   $HOSTNAME"
    [ -n "$MIRROR" ]  && INFOTEXT="$INFOTEXT
    Using mirror:    $MIRROR"
 
    INFOTEXT="$INFOTEXT
 
-Is this ok for you? Notice: canceling will exit ${PN}."
+Is this ok for you? Notice: selecting 'No' will exit ${PN}."
 
    dialog --title "$PN" --no-collapse \
           --yesno "$INFOTEXT" 0 0
@@ -431,9 +489,20 @@ interactive_mode()
 
   prompt_for_release
 
-  # FIXME: there seems to be a problem with grubdevice if it's /dev/md*
+  prompt_for_hostname
+
+  prompt_for_password
+
+  # use first disk of sw-raid for grub by default, install grub on
+  # all involved disks later on
   if echo "$TARGET" | grep -q '/dev/md' ; then
-     echo "debug: SELECTED_PARTITIONS = $SELECTED_PARTITIONS">&2
+     if [ -n "$SELECTED_PARTITIONS" ] ; then # using sw-raid
+        # use hdX and not hdX,Y for $GRUB
+        TMPDEVICE=$(echo ${SELECTED_PARTITIONS} | awk '{print $1}') # use first disk only
+        GRUB="$(grubdevice ${TMPDEVICE%%[0-9]})" # like: hd0
+        GROOT="$(grubdevice ${TMPDEVICE})"       # like: hd0,0
+        echo "debug: GRUB = $GRUB - GROOT = $GROOT" >/tmp/debug # FIXME
+     fi
   else
      [ -n "$BOOT_PARTITION" ] && GRUB="$(grubdevice $BOOT_PARTITION)"
      [ -n "$TARGET" ]         && GROOT="$(grubdevice $TARGET)"
@@ -456,7 +525,7 @@ fi
 if [ -n "$TARGET" ] ; then
    SHORT_TARGET="${TARGET##*/}"
 else
-   eerror "Please adjust /etc/debootstrap/config or..."
+   eerror "Please adjust $CONFFILES/config or..."
    eerror "... use the interactive version for configuration before running ${0}" ; eend 1
    exit 1
 fi
@@ -522,21 +591,6 @@ ISODIR=${ISO##file:}
 ISODIR=${ISODIR%%/}
 # }}}
 
-# provide variables to chroot system {{{
-CHROOT_VARIABLES="/var/cache/grml-debootstrap/variables_${SHORT_TARGET}"
-touch $CHROOT_VARIABLES
-chmod 600 $CHROOT_VARIABLES # make sure nobody except root can read it
-[ -n "$ARCH" ]   && echo "ARCH=$ARCH"     >  $CHROOT_VARIABLES
-[ -n "$GRUB" ]   && echo "GRUB=$GRUB"     >> $CHROOT_VARIABLES
-[ -n "$GROOT" ]  && echo "GROOT=$GROOT"   >> $CHROOT_VARIABLES
-[ -n "$TARGET" ] && echo "TARGET=$TARGET" >> $CHROOT_VARIABLES
-[ -n "$ISO" ]    && echo "ISO=$ISO"       >> $CHROOT_VARIABLES
-[ -n "$ISODIR" ] && echo "ISODIR=$ISO"    >> $CHROOT_VARIABLES
-[ -n "$MIRROR" ] && echo "MIRROR=$MIRROR" >> $CHROOT_VARIABLES
-[ -n "$MIRROR" ] && echo "CHROOTMIRROR=$MIRROR" >> $CHROOT_VARIABLES
-[ -n "$ROOTPASSWORD" ] && echo "ROOTPASSWORD=$ROOTPASSWORD" >> $CHROOT_VARIABLES
-# }}}
-
 # helper functions {{{
 # we want to exit smoothly and clean:
 bailout(){
@@ -606,6 +660,7 @@ mkfs() {
   if [ -n "$MKFS" ] ; then
      einfo "Running $MKFS on $TARGET"
      $MKFS $TARGET
+     TARGET_UUID="$(vol_id -u $TARGET 2>/dev/null || echo '')"
      eend $?
   fi
 }
@@ -649,10 +704,14 @@ debootstrap_system() {
   if ! grep -q $MNTPOINT /proc/mounts ; then
      mount_target
   fi
-  if grep -q $MNTPOINT /proc/mounts ; then
-     einfo "Running $DEBOOTSTRAP for release ${RELEASE}${ARCHINFO} using ${MIRROR}${ISO}"
-     [ -n "$MIRROR" ] && $DEBOOTSTRAP $ARCHCMD $RELEASE $MNTPOINT $MIRROR || \
-     $DEBOOTSTRAP $ARCHCMD $RELEASE $MNTPOINT $ISO
+  if [ "$_opt_nodebootstrap" ]; then
+     einfo "Skipping debootstrap as requested."
+     return
+  fi
+  if grep -q $MNTPOINT /proc/mounts || [ -n "$DIRECTORY" ] ; then
+     einfo "Running $DEBOOTSTRAP $DEBOOTSTRAP_OPT for release ${RELEASE}${ARCHINFO} using ${MIRROR}${ISO}"
+     [ -n "$MIRROR" ] && $DEBOOTSTRAP $ARCHCMD $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $MIRROR || \
+     $DEBOOTSTRAP $ARCHCMD $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $ISO
      eend $?
   else
      eerror "Error: $MNTPOINT not mounted, can not continue."
@@ -664,57 +723,106 @@ debootstrap_system() {
 # prepare chroot via chroot-script {{{
 preparechroot() {
   einfo "Preparing chroot system"
-  cp $CONFFILES/chroot-script $MNTPOINT/bin/chroot-script
+
+  # provide variables to chroot system
+  CHROOT_VARIABLES="/var/cache/grml-debootstrap/variables_${SHORT_TARGET}"
+  touch $CHROOT_VARIABLES
+  chmod 600 $CHROOT_VARIABLES # make sure nobody except root can read it
+  echo "# Configuration of ${PN}"                              > $CHROOT_VARIABLES
+  [ -n "$ARCH" ]         && echo "ARCH=$ARCH"                 >> $CHROOT_VARIABLES
+  [ -n "$GROOT" ]        && echo "GROOT=$GROOT"               >> $CHROOT_VARIABLES
+  [ -n "$GRUB" ]         && echo "GRUB=$GRUB"                 >> $CHROOT_VARIABLES
+  [ -n "$HOSTNAME" ]     && echo "HOSTNAME=$HOSTNAME"         >> $CHROOT_VARIABLES
+  [ -n "$ISODIR" ]       && echo "ISODIR=$ISO"                >> $CHROOT_VARIABLES
+  [ -n "$ISO" ]          && echo "ISO=$ISO"                   >> $CHROOT_VARIABLES
+  [ -n "$MIRROR" ]       && echo "CHROOTMIRROR=$MIRROR"       >> $CHROOT_VARIABLES
+  [ -n "$MIRROR" ]       && echo "MIRROR=$MIRROR"             >> $CHROOT_VARIABLES
+  [ -n "$KEEP_SRC_LIST" ] && echo "KEEP_SRC_LIST=$KEEP_SRC_LIST" >> $CHROOT_VARIABLES
+  [ -n "$PACKAGES" ]     && echo "PACKAGES=$PACKAGES"         >> $CHROOT_VARIABLES
+  [ -n "$ROOTPASSWORD" ] && echo "ROOTPASSWORD=$ROOTPASSWORD" >> $CHROOT_VARIABLES
+  [ -n "$TARGET" ]       && echo "TARGET=$TARGET"             >> $CHROOT_VARIABLES
+  [ -n "$TARGET_UUID" ]  && echo "TARGET_UUID=$TARGET_UUID"   >> $CHROOT_VARIABLES
+
+  cp $VERBOSE $CONFFILES/chroot-script $MNTPOINT/bin/chroot-script
   chmod 755 $MNTPOINT/bin/chroot-script
   mkdir $MNTPOINT/etc/debootstrap/
 
   # make sure we have our files for later use via chroot-script
-  cp /etc/debootstrap/config    $MNTPOINT/etc/debootstrap/
+  cp $VERBOSE $CONFFILES/config    $MNTPOINT/etc/debootstrap/
   # make sure we adjust the configuration variables accordingly:
-  sed -i "s/RELEASE=.*/RELEASE=\"$RELEASE\"/" $MNTPOINT/etc/debootstrap/config
-  sed -i "s/TARGET=.*/TARGET=\"$TARGET\"/"    $MNTPOINT/etc/debootstrap/config
-  sed -i "s/GRUB=.*/GRUB=\"$GRUB\"/"          $MNTPOINT/etc/debootstrap/config
-  sed -i "s/GROOT=.*/GROOT=\"$GROOT\"/"       $MNTPOINT/etc/debootstrap/config
-
-  cp /etc/debootstrap/packages  $MNTPOINT/etc/debootstrap/packages
+  sed -i "s#RELEASE=.*#RELEASE=\"$RELEASE\"#" $MNTPOINT/etc/debootstrap/config
+  sed -i "s#TARGET=.*#TARGET=\"$TARGET\"#"    $MNTPOINT/etc/debootstrap/config
+  sed -i "s#GRUB=.*#GRUB=\"$GRUB\"#"          $MNTPOINT/etc/debootstrap/config
+  sed -i "s#GROOT=.*#GROOT=\"$GROOT\"#"       $MNTPOINT/etc/debootstrap/config
+
+  # package selection:
+  cp $VERBOSE ${_opt_packages:-$CONFFILES/packages} \
+    $MNTPOINT/etc/debootstrap/packages
+
+  # debconf preseeding:
+  _opt_debconf=${_opt_debconf:-$CONFFILES/debconf-selections}
+  [ -f $_opt_debconf -a "$DEBCONF" = 'yes' ] && \
+    cp $VERBOSE $_opt_debconf $MNTPOINT/etc/debootstrap/debconf-selections
+
+  # copy scripts that should be executed inside the chroot:
+  _opt_chroot_scripts=${_opt_chroot_scripts:-$CONFFILES/chroot-scripts/}
+  [ -d $_opt_chroot_scripts -a "$CHROOT_SCRIPTS" = 'yes' ] && {
+    mkdir -p $MNTPOINT/etc/debootstrap/chroot-scripts
+    cp -a $VERBOSE $_opt_chroot_scripts/* $MNTPOINT/etc/debootstrap/chroot-scripts/
+  }
 
   # notice: do NOT use $CHROOT_VARIABLES inside chroot but statically file instead!
-  cp $CHROOT_VARIABLES          $MNTPOINT/etc/debootstrap/variables
+  cp $VERBOSE $CHROOT_VARIABLES  $MNTPOINT/etc/debootstrap/variables
 
-  cp -a /etc/debootstrap/extrapackages/ $MNTPOINT/etc/debootstrap/
+  cp $VERBOSE -a -L $CONFFILES/extrapackages/ $MNTPOINT/etc/debootstrap/
 
   # make sure we can access network [relevant for cdebootstrap]
-  [ -f "$MNTPOINT/etc/resolv.conf" ] || cp /etc/resolv.conf $MNTPOINT/etc/resolv.conf
+  [ -f "$MNTPOINT/etc/resolv.conf" ] || cp $VERBOSE /etc/resolv.conf $MNTPOINT/etc/resolv.conf
 
   # provide system's /etc/hosts to the target:
   if ! [ -f "$MNTPOINT/etc/hosts" ] ; then
-     cp /etc/hosts $MNTPOINT/etc/hosts
-     sed -i "s/127.0.0.1 .*/127.0.0.1       localhost  $HOSTNAME/" /etc/hosts
+     cp $VERBOSE /etc/hosts $MNTPOINT/etc/hosts
   fi
 
   # setup default locales
-  [ -n "$LOCALES" ] && cp /etc/debootstrap/locale.gen  $MNTPOINT/etc/locale.gen
+  [ -n "$LOCALES" ] && cp $VERBOSE $CONFFILES/locale.gen  $MNTPOINT/etc/locale.gen
 
   # MAKEDEV is just a forking bomb crap, let's do it on our own instead :)
   ( cd $MNTPOINT/dev && tar zxf /etc/debootstrap/devices.tar.gz )
 
-  # copy any existing existing files to chroot
-  [ -d /etc/debootstrap/boot  ] && cp -a /etc/debootstrap/boot/*  $MNTPOINT/boot/
-  [ -d /etc/debootstrap/etc   ] && cp -a /etc/debootstrap/etc/*   $MNTPOINT/etc/
-  [ -d /etc/debootstrap/share ] && cp -a /etc/debootstrap/share/* $MNTPOINT/share/
-  [ -d /etc/debootstrap/usr   ] && cp -a /etc/debootstrap/usr/*   $MNTPOINT/usr/
-  [ -d /etc/debootstrap/var   ] && cp -a /etc/debootstrap/var/*   $MNTPOINT/var/
+  # copy any existing files to chroot
+  [ -d $CONFFILES/bin   ] && cp $VERBOSE -a -L $CONFFILES/bin/*   $MNTPOINT/bin/
+  [ -d $CONFFILES/boot  ] && cp $VERBOSE -a -L $CONFFILES/boot/*  $MNTPOINT/boot/
+  [ -d $CONFFILES/etc   ] && cp $VERBOSE -a -L $CONFFILES/etc/*   $MNTPOINT/etc/
+  [ -d $CONFFILES/sbin  ] && cp $VERBOSE -a -L $CONFFILES/sbin/*  $MNTPOINT/sbin/
+  [ -d $CONFFILES/share ] && cp $VERBOSE -a -L $CONFFILES/share/* $MNTPOINT/share/
+  [ -d $CONFFILES/usr   ] && cp $VERBOSE -a -L $CONFFILES/usr/*   $MNTPOINT/usr/
+  [ -d $CONFFILES/var   ] && cp $VERBOSE -a -L $CONFFILES/var/*   $MNTPOINT/var/
 
   # copy local network setup to chroot
   if [ -r /etc/network/interfaces -a ! -r "${MNTPOINT}"/etc/network/interfaces ] ; then
      [ -d $MNTPOINT/etc/network ] || mkdir $MNTPOINT/etc/network
-     cp /etc/network/interfaces $MNTPOINT/etc/network/interfaces
+     cp $VERBOSE /etc/network/interfaces $MNTPOINT/etc/network/interfaces
   fi
 
   eend 0
 }
 # }}}
 
+# execute all scripts in /etc/debootstrap/scripts/ {{{
+execute_scripts() {
+   if [ -d "$_opt_scripts" ] || [ "$SCRIPTS" = 'yes' ] ; then
+      [ -d "$_opt_scripts" ] && scripts="$_opt_scripts" || scripts="$CONFFILES/scripts/"
+      for script in ${scripts}/* ; do
+         if [ -x "$script" ] ; then
+            einfo "Executing script $script"
+            $script ; eend $?
+         fi
+      done
+   fi
+}
+# }}}
+
 # execute chroot-script {{{
 chrootscript() {
   if ! [ -r "$MNTPOINT/bin/chroot-script" ] ; then
@@ -737,15 +845,19 @@ grub_install() {
      echo "Notice: \$GRUB or \$GROOT not defined, will not install grub therefor."
   elif [ -n "$SELECTED_PARTITIONS" ] ; then # using sw-raid
      for device in $SELECTED_PARTITIONS ; do
-        GRUB=$(grubdevice $device)
+        # TMPDEVICE=$(echo ${SELECTED_PARTITIONS} | awk '{print $1}')
+        # GRUB="$(grubdevice ${TMPDEVICE})"
+        # GRUB="$(grubdevice ${TMPDEVICE%%[0-9]})"
+        # GRUB=$(grubdevice $device)
+        GRUB="$(grubdevice ${device%%[0-9]})"
         einfo "Installing grub on ${GRUB}:"
-        [ -x /usr/sbin/grub-install ] && GRUBINSTALL=/usr/sbin/grub-install || GRUBINSTALL=/sbin/grub-install
+        [ -x /usr/sbin/grub-install ] && GRUBINSTALL="/usr/sbin/grub-install --no-floppy" || GRUBINSTALL="/sbin/grub-install --no-floppy"
         $GRUBINSTALL --root-directory="$MNTPOINT" "(${GRUB})"
         eend $?
      done
   else
      einfo "Installing grub on ${GRUB}:"
-     [ -x /usr/sbin/grub-install ] && GRUBINSTALL=/usr/sbin/grub-install || GRUBINSTALL=/sbin/grub-install
+     [ -x /usr/sbin/grub-install ] && GRUBINSTALL="/usr/sbin/grub-install --no-floppy" || GRUBINSTALL="/sbin/grub-install --no-floppy"
      $GRUBINSTALL --root-directory="$MNTPOINT" "(${GRUB})"
      eend $?
   fi
@@ -784,7 +896,8 @@ fscktool() {
 
 # now execute all the functions {{{
 for i in mkfs tunefs mount_target debootstrap_system preparechroot \
-         chrootscript grub_install umount_chroot fscktool ; do
+         chrootscript execute_scripts grub_install umount_chroot   \
+         fscktool ; do
     if stage "${i}" ; then
        $i && ( stage "${i}" done && rm -f "${STAGES}/${i}" ) || bailout 2 "i"
     fi
@@ -792,10 +905,12 @@ done
 # }}}
 
 # finalize {{{
+einfo "Removing ${CHROOT_VARIABLES}" ; rm "$CHROOT_VARIABLES" ; eend $?
+einfo "Removing ${STAGES}" ; rmdir "$STAGES" ; eend $?
+
 # Remove temporary mountpoint again
 if echo "$MNTPOINT" | grep -q '/mnt/debootstrap\.' ; then
    einfo "Removing directory ${MNTPOINT}" ; rmdir "$MNTPOINT" ; eend $?
-   einfo "Removing ${CHROOT_VARIABLES}" ; rm "$CHROOT_VARIABLES" ; eend $?
 fi
 # }}}